package com.family168.jbpm4book.x01.x05forkjoin;

import java.util.*;

import com.family168.jbpm4book.x01.BaseTests;

import org.jbpm.api.*;
import org.jbpm.api.cmd.*;
import org.jbpm.api.job.*;


public class X0504Exclusive1Test extends BaseTests {
    public void testForkJoin() {
        this.deployJpdlClasspath(
            "jpdl/x05forkjoin/X0504Exclusive1Test.jpdl.xml");

        ProcessInstance processInstance = executionService
            .startProcessInstanceByKey("X0504Exclusive1Test");
        Job job = null;
        List<Job> jobs = null;
        // start
        executeJob();
        // fork
        executeJobs();
        // join
        executeJob();
        executeJob();
        executeJob();
        System.out.println(executionService.findProcessInstanceById(
                processInstance.getId()));
        assertNull(executionService.findProcessInstanceById(
                processInstance.getId()));
    }

    void executeJob() {
        Job job = managementService.createJobQuery().page(0, 1)
                                   .uniqueResult();
        managementService.executeJob(job.getId());
    }

    void executeJobs() {
        processEngine.execute(new Command() {
                public Object execute(Environment env) {
                    List<Job> jobs = env.get(ManagementService.class)
                                        .createJobQuery().list();

                    for (Job job : jobs) {
                        env.get(ManagementService.class)
                           .executeJob(job.getId());
                    }

                    return null;
                }
            });
    }
}
